<div class='row'>
    <div class="col-sm-8 col-sm-offset2">
        <form (ngSubmit)="onSubmit()" [formGroup]="userForm">
            <div class="form-group">
                <label for="username">
                    username
                </label>
                <input type="text" id="username" class="form-control" placeholder="username" [formControl]="usernameCtl">
                <small class="text-danger" *ngIf="usernameCtl.hasError('required')"> required </small>
                <small class="text-danger" *ngIf="usernameCtl.hasError('minlength')"> 
                    minimum length is {{ usernameCtl.errors?.minlength.requiredLength }} </small>
            </div>
            <div class="form-group">
                <label for="password">
                    password
                </label>
                <input type="password" id="password" class="form-control" [formControl]="passwordCtl">
                <small class="text-danger" *ngIf="passwordCtl.hasError('required')"> require </small>
                <small class="text-danger" *ngIf="passwordCtl.errors?.forbidden"> username and password are equals </small>
                <small class="text-danger" *ngIf="passwordCtl.hasError('minlength')"> 
                    minimum length is {{ passwordCtl.errors?.minlength.requiredLength }} </small>
            </div>
            <button class="btn btn-primary" type="submit" [disabled]="userForm.invalid"> save </button>
        </form>
    </div>
</div>